diff --git a/lib/compiler_rt/lse_atomics.zig b/lib/compiler_rt/lse_atomics.zig
index c87d80c857b..2471a453655 100644
--- a/lib/compiler_rt/lse_atomics.zig
+++ b/lib/compiler_rt/lse_atomics.zig
@@ -708,19 +696,19 @@ fn __aarch64_ldadd2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldclr2_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x40000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -729,19 +717,19 @@ fn __aarch64_ldclr2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldeor2_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x40000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -750,19 +738,19 @@ fn __aarch64_ldeor2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldset2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldset2_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x3000 + 0x40000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -771,20 +759,19 @@ fn __aarch64_ldset2_acq(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_cas2_rel(expected: u16, desired: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_cas2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x08a07c41 + 0x40000000 + 0x008000
-        \\
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        uxth    w16, w0
         \\0:
@@ -794,20 +781,19 @@ fn __aarch64_cas2_rel(expected: u16, desired: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w17, w1, [x2]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [expected] "{w0}" (expected),
-          [desired] "{w1}" (desired),
-          [ptr] "{x2}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_swp2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_swp2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38208020 + 0x40000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -815,19 +801,19 @@ fn __aarch64_swp2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w17, w16, [x1]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldadd2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldadd2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x0000 + 0x40000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -836,19 +822,19 @@ fn __aarch64_ldadd2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldclr2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x40000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -857,19 +843,19 @@ fn __aarch64_ldclr2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldeor2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x40000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -878,19 +864,19 @@ fn __aarch64_ldeor2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldset2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldset2_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x3000 + 0x40000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -899,20 +885,19 @@ fn __aarch64_ldset2_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_cas2_acq_rel(expected: u16, desired: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_cas2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x08a07c41 + 0x40000000 + 0x408000
-        \\
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        uxth    w16, w0
         \\0:
@@ -922,20 +907,19 @@ fn __aarch64_cas2_acq_rel(expected: u16, desired: u16, ptr: *u16) callconv(.C) u
         \\        stlxrh   w17, w1, [x2]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [expected] "{w0}" (expected),
-          [desired] "{w1}" (desired),
-          [ptr] "{x2}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_swp2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_swp2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38208020 + 0x40000000 + 0xc00000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -943,19 +927,19 @@ fn __aarch64_swp2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w17, w16, [x1]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldadd2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldadd2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x0000 + 0x40000000 + 0xc00000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -964,19 +948,19 @@ fn __aarch64_ldadd2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldclr2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x40000000 + 0xc00000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -985,19 +969,19 @@ fn __aarch64_ldclr2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldeor2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x40000000 + 0xc00000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1006,19 +990,19 @@ fn __aarch64_ldeor2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldset2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
+fn __aarch64_ldset2_acq_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x3000 + 0x40000000 + 0xc00000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1027,20 +1011,19 @@ fn __aarch64_ldset2_acq_rel(val: u16, ptr: *u16) callconv(.C) u16 {
         \\        stlxrh   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u16),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_cas4_relax(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_cas4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x08a07c41 + 0x80000000 + 0x000000
-        \\
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1050,20 +1033,19 @@ fn __aarch64_cas4_relax(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32
         \\        stxr   w17, w1, [x2]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [expected] "{w0}" (expected),
-          [desired] "{w1}" (desired),
-          [ptr] "{x2}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_swp4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_swp4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38208020 + 0x80000000 + 0x000000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1071,19 +1053,19 @@ fn __aarch64_swp4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w17, w16, [x1]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldadd4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldadd4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x0000 + 0x80000000 + 0x000000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1092,19 +1074,19 @@ fn __aarch64_ldadd4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldclr4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x80000000 + 0x000000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1113,19 +1095,19 @@ fn __aarch64_ldclr4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldeor4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x80000000 + 0x000000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1134,19 +1116,19 @@ fn __aarch64_ldeor4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldset4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldset4_relax() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x3000 + 0x80000000 + 0x000000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1155,20 +1137,19 @@ fn __aarch64_ldset4_relax(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_cas4_acq(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_cas4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x08a07c41 + 0x80000000 + 0x400000
-        \\
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1178,20 +1159,19 @@ fn __aarch64_cas4_acq(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w17, w1, [x2]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [expected] "{w0}" (expected),
-          [desired] "{w1}" (desired),
-          [ptr] "{x2}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_swp4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_swp4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38208020 + 0x80000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1199,19 +1179,19 @@ fn __aarch64_swp4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w17, w16, [x1]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldadd4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldadd4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x0000 + 0x80000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1220,19 +1200,19 @@ fn __aarch64_ldadd4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldclr4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x80000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1241,19 +1221,19 @@ fn __aarch64_ldclr4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldeor4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x80000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1262,19 +1242,19 @@ fn __aarch64_ldeor4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldset4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldset4_acq() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x3000 + 0x80000000 + 0x800000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1283,20 +1263,19 @@ fn __aarch64_ldset4_acq(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_cas4_rel(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_cas4_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x08a07c41 + 0x80000000 + 0x008000
-        \\
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1306,20 +1285,19 @@ fn __aarch64_cas4_rel(expected: u32, desired: u32, ptr: *u32) callconv(.C) u32 {
         \\        stlxr   w17, w1, [x2]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [expected] "{w0}" (expected),
-          [desired] "{w1}" (desired),
-          [ptr] "{x2}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_swp4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_swp4_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38208020 + 0x80000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1327,19 +1305,19 @@ fn __aarch64_swp4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stlxr   w17, w16, [x1]
         \\        cbnz   w17, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldadd4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldadd4_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x0000 + 0x80000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1348,19 +1326,19 @@ fn __aarch64_ldadd4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stlxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldclr4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldclr4_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x1000 + 0x80000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
@@ -1369,19 +1347,19 @@ fn __aarch64_ldclr4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
         \\        stlxr   w15, w17, [x1]
         \\        cbnz   w15, 0b
         \\1:
-        : [ret] "={w0}" (-> u32),
-        : [val] "{w0}" (val),
-          [ptr] "{x1}" (ptr),
-          [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
+        \\        ret
+        :
+        : [__aarch64_have_lse_atomics] "{w16}" (__aarch64_have_lse_atomics),
         : "w15", "w16", "w17", "memory"
     );
+    unreachable;
 }
-fn __aarch64_ldeor4_rel(val: u32, ptr: *u32) callconv(.C) u32 {
+fn __aarch64_ldeor4_rel() align(16) callconv(.Naked) void {
     @setRuntimeSafety(false);
-    return asm volatile (
+    asm volatile (
         \\        cbz     w16, 8f
         \\        .inst 0x38200020 + 0x2000 + 0x80000000 + 0x400000
-        \\        cbz     wzr, 1f
+        \\        ret
         \\8:
         \\        mov    w16, w0
         \\0:
